;------------------------------------------------------------
;------------------------------------------------------------
;------------------------------------------------------------
;+
; NAME: jul2date
;
; PURPOSE: gives yyyymmdd date equivalent of a julian day
;
; CATEGORY: calendar
;
; CALLING SEQUENCE: date = jul2date(jday)
;
; INPUTS:jday: julian day
;
; KEYWORD PARAMETERS: None
;
; OUTPUTS: date in yyyymmdd format
;
; COMMON BLOCKS: None
;
; SIDE EFFECTS:
;
; RESTRICTIONS:
;
; EXAMPLE:
;
;    IDL> print, jul2date(julday(12,23,1999))
;        19991223
;
; MODIFICATION HISTORY: Sebastien Masson (smasson@lodyc.jussieu.fr)
;                       June 2005
;-
;------------------------------------------------------------
;------------------------------------------------------------
;------------------------------------------------------------
function jul2date, jday
  caldat, jday, month, day, year
  return, 10000L*year+100L*month+day
end
