;------------------------------------------------------------
;------------------------------------------------------------
;------------------------------------------------------------
;+
; NAME:scanoasis
;
; PURPOSE:scan an Oasis file (version < 2.5)
;
; CATEGORY:know what is inside
;
; CALLING SEQUENCE:scanoasis, filename
; 
; INPUTS: filename: the file name!
;
; KEYWORD PARAMETERS:
;
; OUTPUTS:
;
; COMMON BLOCKS:
;
; SIDE EFFECTS: List the variable names included in a Oasis file
;
; RESTRICTIONS:
;
; EXAMPLE:  IDL> scanoasis,'grids_orca_t106'
;
; MODIFICATION HISTORY:Sebastien Masson (smasson@lodyc.jussieu.fr)
;                      July 01, 2002
;-
;------------------------------------------------------------
;------------------------------------------------------------
;------------------------------------------------------------

PRO scanoasis, filename

   openr, unit,filename , /F77_UNFORMATTED, /GET_LUN, /SWAP_IF_LITTLE_ENDIAN $
    , error=err
   if err ne 0 then begin
      print,!err_string
      return
   endif

   char8 = '12345678'
   WHILE NOT EOF(unit) DO BEGIN
      readu, unit, char8
      print,  char8
      readu, unit
   ENDWHILE

   free_lun,unit
   return
end
